package jp.sourceforge.freegantt.data.undo;

import javax.swing.undo.AbstractUndoableEdit;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

import jp.sourceforge.freegantt.data.Member;
import jp.sourceforge.freegantt.data.Project;

public class CreateMemberEdit extends AbstractUndoableEdit {
	private static final long serialVersionUID = 7766452757716959928L;

	Project project;
	Member newMember;
	int index;
	
	public CreateMemberEdit(Project project, Member member, int index) {
		this.project = project;
		this.newMember = member.clone();
		this.index = index;
	}

	@Override
	public void undo() throws CannotUndoException {
		System.out.println("Undo " + getClass().toString());
		super.undo();
		project.getController().removeMember(index);
	}

	@Override
	public void redo() throws CannotRedoException {
		super.redo();
		project.getController().addMember(newMember, index);
	}

	@Override
	public void die() {
		super.die();
		project = null;
		newMember = null;
	}
}
